 /******************************************************************************
  * @file    PT32X003_pwr.h
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/5/27
  * @brief    This file contains all the functions prototypes for the PWR firmware library.
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/


/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef PT32X003_PWR_H
#define PT32X003_PWR_H

#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "PT32X003.h"


/** @addtogroup PWR
  * @{
  */ 





/** @defgroup IS_PWR_SLEEP_ENTRY  **/
#define PWR_SLEEPEntry_WFI              ((u8)0x01)
#define PWR_SLEEPEntry_WFE              ((u8)0x02)
#define IS_PWR_SLEEP_ENTRY(ENTRY)	(((ENTRY) == PWR_SLEEPEntry_WFI) ||\
									((ENTRY) == PWR_SLEEPEntry_WFE))
 

/** @defgroup PWR_STOP_mode_entry 
  * @{
  */

#define PWR_STANDBYEntry_WFI               ((u8)0x01)
#define PWR_STANDBYEntry_WFE               ((u8)0x02)
#define IS_PWR_STANDBY_ENTRY(ENTRY)	(((ENTRY) == PWR_STANDBYEntry_WFI) || \
										((ENTRY) == PWR_STANDBYEntry_WFE))
 

/* Exported macro ------------------------------------------------------------*/
/* Exported functions ------------------------------------------------------- */
void PWR_EnterSleepMode(u8 PWR_SLEEPEntry);
void PWR_EnterSTANDBYMode(u8 PWR_DeepStandbyEntry);

#ifdef __cplusplus
}
#endif

#endif 

