  /******************************************************************************
  * @file    PT32X003_rcc.h
  * @author  ӦÿŶ
  * @version V1.0.0
  * @date    2022/5/27
  * @brief    This file contains all the functions prototypes for the SYS firmware library.
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef PT32X003_RCC_H
#define PT32X003_RCC_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "PT32X003.h"


/** @addtogroup SYSTEM CONTROL
  * @{
  */


#define RCC_FLAG_SFR           RCC_RSR_SFR
#define RCC_FLAG_IWDGR         RCC_RSR_IWDGR
#define RCC_FLAG_POR           RCC_RSR_POR
#define RCC_FLAG_PINR         RCC_RSR_PINR

#define IS_RSTCU_FLAG(FLAG)	((FLAG == RCC_FLAG_SFR)    || \
							(FLAG == RCC_FLAG_IWDGR)   || \
							(FLAG == RCC_FLAG_POR)     || \
							(FLAG == RCC_FLAG_PINR))

#define RCC_RSTSource_Soft      RCC_RCR_HREN
#define IS_RSTEN_SOURCE(SOURCE)    ((SOURCE == RCC_RSTSource_Soft))


/* Exported macro ------------------------------------------------------------*/
/* Exported functions ---------------------------------------------------------*/
u32 RCC_GetSYSCLKFreq(void);
u32 RCC_GetHCLKFreq(void);
u32 RCC_GetPCLKFreq(void);
FlagStatus RCC_GetResetFlagStatus(u32 RSTCU_RSTF);
void RCC_ClearResetFlag(u32 RSTCU_RSTF);
void RCC_RestConfig(u32 RstSource, FunctionalState NewState);
/**
  * @}
  */
  
#ifdef __cplusplus
}
#endif

#endif 


