/**
  ******************************************************************************
  * @file    system_PT32X005.c
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2022/2/10
  * @brief   
  ******************************************************************************
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  */



#include "PT32X003.h"

void Wait_ClockReady(void)
{//not modify the delay param...
	volatile int delay;
	for (delay = 0; delay < 10000; delay++);
}

//<<< Use Configuration Wizard in Context Menu >>>

/*--------------------- ʱ ----------------------------------
//
//    <h> HSIʱ
//      <o>    HCLKƵ
//                <0=> 0
//                <1=> 2
//                <2=> 3
//                <3=> 4
//                <4=> 5
//                <5=> 6
//                <6=> 7
//                <7=> 8
//                <8=> 9
//                <9=> 10
//                <10=> 11
//                <11=> 12
//                <12=> 13
//                <13=> 14
//                <14=> 15
//                <15=> 16
//                <16=> 17
//                <17=> 18
//                <18=> 19
//                <19=> 20
//                <20=> 21
//                <21=> 22
//                <22=> 23
//                <23=> 24
//                <24=> 25
//                <25=> 26
//                <26=> 27
//                <27=> 28
//                <28=> 29
//                <29=> 30
//                <30=> 31
//                <31=> 32
//                <i> ĬϵͳʱԴƵ0
//      <o1>    PCLK Ƶ
//                <0=> 0
//                <1=> 2
//                <2=> 3
//                <3=> 4
//                <4=> 5
//                <5=> 6
//                <6=> 7
//                <7=> 8
//                <8=> 9
//                <9=> 10
//                <10=> 11
//                <11=> 12
//                <12=> 13
//                <13=> 14
//                <14=> 15
//                <15=> 16
//                <16=> 17
//                <17=> 18
//                <18=> 19
//                <19=> 20
//                <20=> 21
//                <21=> 22
//                <22=> 23
//                <23=> 24
//                <24=> 25
//                <25=> 26
//                <26=> 27
//                <27=> 28
//                <28=> 29
//                <29=> 30
//                <30=> 31
//                <31=> 32
//                <i> ĬPCLKƵ0 
//       <o2>   ӳʱ
//                <0=> ӳ٣65536SYS_CLKʱ
//                <1=> δӳ٣57344SYS_CLKʱ
//                <2=> Сӳ٣40960SYS_CLKʱ
//                <3=> Сӳ٣33792SYS_CLKʱ 
//    </h>
//    <e3> LSIʱ
//                <i> Ĭֵʹ
//    </e>
//
//    <h> FLASH 
//      <o4>   Flash ȡָȴ
//                <0=> 0 WS
//                <1=> 1 WS
//                <2=> 2 WS
//                <3=> 3 WS
//                <4=> 4 WS
//                <5=> 5 WS
//                <6=> 6 WS
//                <7=> 7 WS
//    </h>
//
//    <h> MCO
//      <e5>    MCOʹ
//                <i> ĬϣʹܣPC4ϵͳʱ  
//        <o6>    MCOʱԴѡ
//                <0=> HSI
//                <1=> LSI
//                <i> ĬϵͳʱԴڲHSI  
//        <o7>   MCOƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16 
*/



#define HCLK_DIV                      (0)     
#define PCLK_DIV                      (0)    
#define RCC_WAIT_TIME                    (3)   
#define RC_128K_ENABLE                (1)   
#define FLASH_WAIT_TIME                (3)      
#define MCO_ENABLE                    (0)   
#define MCO_SRCSEL                    (0)   
#define MCO_DIV                       (0)  





/**
 * Initialize the system
 *
 * @param  none
 * @return none
 *
 * @brief  Setup the microcontroller system.
 *         Initialize the System.
 */
extern void Software_Delay(u32 timeBase10ms);
void SystemInit (void)
{

	RCC->CFGR = 0;
    RCC->MCOR = 0;
    RCC->CFGR |= (HCLK_DIV << 4);
	RCC->CFGR |= (PCLK_DIV << 0);
    RCC->CFGR |= (RCC_WAIT_TIME << 16);
    IFMC ->CR= ((IFMC_CR_KEY_MAIN) | (FLASH_WAIT_TIME << 5)) ; //wait state
    
#if (RC_128K_ENABLE == 0)
    RCC->LCR &= ~0x01;
#else 
    RCC->LCR |= 0x01;          
#endif


  
#if (MCO_ENABLE == 1)
	AFIOC->AFS0 |= (1 << 16); //PC4
	RCC->MCOR = (MCO_DIV | (MCO_SRCSEL << 4) );

#endif

}

/**
  * @}
  */
