/******************************************************************************
  * @Example PT32X003_TIMBase
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2020/1/27
  * @brief   ͨʱLED1ʱ˸
  ******************************************************************************
  * @attention	ʹø,
  *				ҪϵJ17RGB_R,RGB_G,RGB_B̽
  *				ṩʱòο˶궨塰TIM2~4_SEL,Ӧĺ궨ֵΪ1жӦĶʱ	
  *
  *****************************************************************************/
#include "PT32X003.h"

#define TIM2_SEL 1
#define TIM3_SEL 0
#define TIM4_SEL 0

/**
* @brief LEDGPIO
* @param 
* @retval 
*/
void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	//ƫ
	GPIO_Init(GPIOC, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
	GPIO_SetBits(GPIOC, GPIO_Pin_6);					//ÿ⺯GPIO״̬
}

/**
* @brief ʼTIM2
* @param 
* @retval 
*/
void General_TIMER2_Config(void)
{
	TIM_TimeBaseInitTypeDef TimeBaseInit;				//һTIM_TimeBaseInitTypeDef͵Ľṹ
	NVIC_InitTypeDef NVIC_InitStruct;					//һNVIC_InitTypeDef͵Ľṹ
	
	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM2_IRQn;		//ж
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;		//Ƿʹж
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;		//жȼ
	NVIC_Init(&NVIC_InitStruct);						//ʼNVIC
	
	TIM_TimeBaseStructInit(&TimeBaseInit);				//ʹĬֵʼTimeBaseInit
	
	TimeBaseInit.Prescaler = 4799;						//÷Ƶֵ(48000000/(4799+1) = 10000)
	TimeBaseInit.CounterMode = TIM_CounterMode_UP;			//ü
	TimeBaseInit.MatchValue = 10000;					//װֵ
	TimeBaseInit.OVRSTEN = ENABLE;						//Ƿλ
	TIM_TimeBaseInit(TIM2, &TimeBaseInit);				//ʼTIM2

	TIM_ITConfig(TIM2, TIMx_IE_UIE, ENABLE);			//ʹܼж

	TIM_Cmd(TIM2, ENABLE);								//ʹTIM2
	
}

/**
* @brief ʼTIM3
* @param 
* @retval 
*/
void General_TIMER3_Config(void)
{
	TIM_TimeBaseInitTypeDef TimeBaseInit;				//һTIM_TimeBaseInitTypeDef͵Ľṹ
	NVIC_InitTypeDef NVIC_InitStruct;					//һNVIC_InitTypeDef͵Ľṹ
	
	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM3_IRQn;		//ж
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;		//Ƿʹж
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x01;		//жȼ
	NVIC_Init(&NVIC_InitStruct);						//ʼNVIC
	
	TIM_TimeBaseStructInit(&TimeBaseInit);				//ʹĬֵʼTimeBaseInit
	
	TimeBaseInit.Prescaler = 4799;						//÷Ƶֵ(48000000/(4799+1) = 10000)
	TimeBaseInit.CounterMode = TIM_CounterMode_UP;			//ü
	TimeBaseInit.MatchValue = 10000;					//װֵ
	TimeBaseInit.OVRSTEN = ENABLE;						//Ƿλ
	TIM_TimeBaseInit(TIM3, &TimeBaseInit);				//ʼTIM3
	
	TIM_ITConfig(TIM3, TIMx_IE_UIE, ENABLE);			//ʹܼж
	
	TIM_Cmd(TIM3, ENABLE);								//ʹTIM3
	
}

/**
* @brief ʼTIM4
* @param 
* @retval 
*/
void General_TIMER4_Config(void)
{
	TIM_TimeBaseInitTypeDef Time4Init;				//һTIM_TimeBaseInitTypeDef͵Ľṹ
	NVIC_InitTypeDef NVIC_InitStruct;					//һNVIC_InitTypeDef͵Ľṹ
	
	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM4_IRQn;		//ж
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;		//Ƿʹж
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x02;		//жȼ
	NVIC_Init(&NVIC_InitStruct);						//ʼNVIC
		
	Time4Init.Prescaler = 31;						//÷Ƶֵ
	Time4Init.MatchValue = 1000;						//װֵ
	Time4Init.OVRSTEN = ENABLE;						//Ƿλ
	TIM_TimeBaseInit(TIM4,&Time4Init);				//ʼTIM4
	
	TIM_ITConfig(TIM4,TIMx_IE_UIE, ENABLE);			//ʹܼж
	
	TIM_Cmd(TIM4,ENABLE);								//ʹTIM4
	
}

extern u8 Tim_FLAG;

int main (void)
{
	LED_Driver();
	
	#if TIM2_SEL
		General_TIMER2_Config();
	#endif
	
	#if TIM3_SEL
		General_TIMER3_Config();
	#endif
	
	#if TIM4_SEL
		General_TIMER4_Config();
	#endif

	while(1)
	{
		if(Tim_FLAG)
		{
			GPIO_SetBits(GPIOC, GPIO_Pin_6);
		}
		else
		{
			GPIO_ResetBits(GPIOC, GPIO_Pin_6);
		}
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %lu\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


