/******************************************************************************
  * @Example PT32X003_PWM_Breathing_Light
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2020/10/14
  * @brief   ͨPWMʵRGB LEDĺƺЧ         
  ******************************************************************************
  * @attention	ʹø̣
  *				ҪϵJ17RGB_R,RGB_G,RGB_B̽
  *
  *****************************************************************************/
#include "PT32X003.h"


/**
* @brief TIM1
* @param 
* @retval 
*/
void Advanced_TIMER_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOC, AFIO_Pin_6, AFIO_AF_2,ENABLE);	//TIM1_CH1ָ
}

/**
* @brief ʼTIM1ȽϹ
* @param 
* @retval 
*/
void Advanced_TIMER_Mode_Config(void)
{
	PWM_TimeBaseInitTypeDef  TimeBaseInit;					//һPWM_TimeBaseInitTypeDef͵Ľṹ
	PWM_OCInitTypeDef		OutPutInit;						//һPWM_OCInitTypeDef͵Ľṹ
	
	/*ʱ*/	
	TimeBaseInit.PWM_ClockSel = PWM_ClockSel_SYSCLK;						//ʱԴ
	TimeBaseInit.PWM_Period = 50000;						//װֵ
	TimeBaseInit.PWM_Prescaler = 7;								//÷Ƶֵ
    TimeBaseInit.PWM_CounterMode = PWM_CounterMode_Up;
	PMW_TimeBaseInit(TIM1, &TimeBaseInit);					//ʼTIM1ʱ
	
	/*Ƚ*/
	PWM_OCStructInit(&OutPutInit);							//ʹĬֵʼOutPutInit
	
	OutPutInit.PWM_Channel=PWM_Channel_1;							//òͨ
	OutPutInit.PWM_OCMode=PWM_OCMode_PWM1;					//ֵռձƥĴֵߵƽ
	OutPutInit.PWM_OutputNState=PWM_OutputNState_Disable;	//ʹܻͨ TIM1_OCMR_OC1NE
	OutPutInit.PWM_OCPolarity = PWM_OCPolarity_High;//OCPR
	OutPutInit.PWM_OCIdleState = PWM_OCIdleState_High; //TIM1_OCMR_OIS1
	OutPutInit.PWM_DeathTime=0;									//ʱ0
	OutPutInit.PWM_Pulse=5000;								//ռձ=PWM_Pulse/CounterReload
    
	PWM_OCInit(TIM1,&OutPutInit);							//ʼȽͨ
    
    
	PWM_Cmd(TIM1, ENABLE);									//ʹܶʱ
    
    
}

/**
* @brief PWMռձ
* @param duty:ռձֵȡֵΧΪ0-0xFFFF
* @retval 
*/
void SetDemoPwm_Duty(u16 duty)
{
	TIM1->OCR1 = duty;
    while(!(TIM1->OCR1 == duty));
}

/**
* @brief TIM1ģ
* @param 
* @retval 
*/
void Advanced_Timer_Init(void)
{
	Advanced_TIMER_GPIO_Config();
	Advanced_TIMER_Mode_Config();
}

void Delay(u32 delay)
{
	while(delay > 0)
		delay--;
}

int main (void)
{
	u16 duty = 0;
	Advanced_Timer_Init();
	while(1)
	{
		for(duty=50000;duty>10000;duty--)
		{
			SetDemoPwm_Duty(duty);
			Delay(100);
		}
		for(duty=10000;duty<50000;duty++)
		{
			SetDemoPwm_Duty(duty);
			Delay(100);
		}
	}
}
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %lu\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


