/******************************************************************************
  * @file    PT32X003_it.c
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2020/1/27
  * @brief    This file provides all interrupt service routine.
  *          
  ******************************************************************************
  * @attention
  *
  *
  *****************************************************************************/
  
/* Includes ------------------------------------------------------------------------------------------------*/
#include "PT32X003_it.h"


/** @defgroup IT
  * @brief IT driver modules
  * @{
  */
  
/* Private typedef -----------------------------------------------------------------------------------------*/
/* Private define ------------------------------------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------------------------------------*/
/* Private functions ---------------------------------------------------------------------------------------*/



/*********************************************************************************************************//**
 * @brief   This function handles NMI exception.
 * @retval  None
 ************************************************************************************************************/
void NMI_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles Hard Fault exception.
 * @retval  None
 ************************************************************************************************************/
void HardFault_Handler(void)
{
  	while (1);
}

/*********************************************************************************************************//**
 * @brief   This function handles SVCall exception.
 * @retval  None
 ************************************************************************************************************/
void SVC_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles PendSVC exception.
 * @retval  None
 ************************************************************************************************************/
void PendSV_Handler(void)
{
}


/*********************************************************************************************************//**
 * @brief   This function handles SysTick exception.
 * @retval  None
 ************************************************************************************************************/
void SysTick_Handler(void)
{
}


/*********************************************************************************************************//**
 * @brief   This function handles IFMC interrupt.
 * @retval  None
 ************************************************************************************************************/
void IFMC_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles EXTIA interrupt.
 * @retval  None
 ************************************************************************************************************/
void EXTIA_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles EXTIB interrupt.
 * @retval  None
 ************************************************************************************************************/
void EXTIB_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles EXTIC interrupt.
 * @retval  None
 ************************************************************************************************************/
void EXTIC_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles EXTID interrupt.
 * @retval  None
 ************************************************************************************************************/
void EXTID_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles ADC interrupt.
 * @retval  None
 ************************************************************************************************************/
void ADC_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles SPI interrupt.
 * @retval  None
 ************************************************************************************************************/
void SPI_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles UART0 interrupt.
 * @retval  None
 ************************************************************************************************************/
void UART0_Handler(void)
{	
}

/*********************************************************************************************************//**
 * @brief   This function handles UART1 interrupt.
 * @retval  None
 ************************************************************************************************************/
void UART1_Handler(void)
{	
}

/*********************************************************************************************************//**
 * @brief   This function handles I2C interrupt.
 * @retval  None
 ************************************************************************************************************/
void I2C_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles TIM1 interrupt.
 * @retval  None
 ************************************************************************************************************/
u32 	Isr_capture_Value = 0;
u32 	Isr_capture_Value_2 = 0;
u8		CapIsr_Flag = 0;
extern PWM_ICInitTypeDef	CapPutInit;
void TIM1_Handler(void)
{
	if(PWM_GetFlagStatus(TIM1,PWM_FLAG_IC1F)==SET)			//ȡ־Ƿ
	{
		PWM_ClearFlag(TIM1,PWM_FLAG_IC1F);					//־
		Isr_capture_Value = PWM_GetCapture(TIM1,PWM_Channel_1);	//ȡֵ
	}
	else if(PWM_GetFlagStatus(TIM1,PWM_FLAG_IC1R)==SET)
	{
		PWM_ClearFlag(TIM1,PWM_FLAG_IC1R);
		Isr_capture_Value_2 = PWM_GetCapture(TIM1,PWM_Channel_1);
		CapIsr_Flag = 1;
	}	
}

u8 Tim_FLAG=0;
/*********************************************************************************************************//**
 * @brief   This function handles TIM2 interrupt.
 * @retval  None
 ************************************************************************************************************/
void TIM2_Handler(void)
{
	TIM_ClearFlag(TIM2, TIMx_SR_UIF);	//־
	Tim_FLAG++;
	if(Tim_FLAG>2) Tim_FLAG=0;	
}

/*********************************************************************************************************//**
 * @brief   This function handles TIM3 interrupt.
 * @retval  None
 ************************************************************************************************************/
void TIM3_Handler(void)
{
}

/*********************************************************************************************************//**
 * @brief   This function handles TIM4 interrupt.
 * @retval  None
 ************************************************************************************************************/
void TIM4_Handler(void)
{
}



/**
  * @}
  */

