/******************************************************************************
  * @Example PT32X003_Input_Capture
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2020/1/27
  * @brief   ͨ߼ʱTIM1һɻʱTIM2Ӳ"ռձ33.3%"źţʹôڴӡߵ͵ƽĳʱ䡣
  *										
  ******************************************************************************
  * @attention	Ϊ384001λֹͣλУ
  *				ʹø̣			
  *						ҪϵJ20RXPD5̽ӣTXPD6̽
  *						ҪϵPC6PD4̽
  *
  *****************************************************************************/
#include "PT32X003.h"


extern u32 	Isr_capture_Value;
extern u32 	Isr_capture_Value_2;
extern u8	CapIsr_Flag;
extern u8	Tim_FLAG;

/**
* @brief GPIOƽת
* @param 
* @retval 
*/
void GPIO_PIN_Configure(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;	//ƫ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;			//ѡGPIO
	GPIO_Init(GPIOD, &GPIO_InitStructure);				//ʼGPIO
	GPIO_SetBits(GPIOD, GPIO_Pin_4);					//GPIO״̬
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_5, AFIO_AF_0,ENABLE);	//RXֹܸ
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_6, AFIO_AF_0,ENABLE);	//TXֹܸ
}

/**
* @brief ʼUARTģĹ乤ʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;					//һUART_InitTypeDef͵Ľṹ
	
	UART_StructInit(&UART_InitStruct);					//ʹĬֵʼUART_InitStruct
	
	UART_InitStruct.UART_BaudRate = 38400;				//ò
	UART_InitStruct.UART_WordLength = UART_WP_8D;		//λ
	UART_InitStruct.UART_StopBits = UART_STOP_1b;		//ֹͣλ
	UART_InitStruct.UART_Parity = UART_PS_EVEN;			//Уλ
	UART_InitStruct.UART_Mode = UART_RE_Enable;			//RXʹ
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;//عر
	
	UART_Init(UART0, &UART_InitStruct);					//ʼUART

	UART_Cmd(UART0, ENABLE);							//ʹUART
}

/**
* @brief UARTģ
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief TIM1
* @param 
* @retval 
*/
void Advanced_TIMER_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOC, AFIO_Pin_6, AFIO_AF_2,ENABLE);	//TIM1_CH1ֹܸ
}

/**
* @brief ʼTIM1벶
* @param 
* @retval 
*/
void Advanced_TIMER_Mode_Config(void)
{
	NVIC_InitTypeDef			NVIC_InitStruct;	//һNVIC_InitTypeDef͵Ľṹ
	PWM_TimeBaseInitTypeDef		TimeBaseInit;		//һPWM_TimeBaseInitTypeDef͵Ľṹ
	PWM_ICInitTypeDef			CapPutInit;			//һPWM_ICInitTypeDef͵Ľṹ
	
	/*ʱ*/
	TimeBaseInit.PWM_ClockSel = PWM_ClockSel_SYSCLK;					//ʱԴ
	TimeBaseInit.PWM_Period = 0xFFFF;			//װֵ
	TimeBaseInit.PWM_Prescaler = 47;					//÷Ƶֵ(ʱʱ=48MHZ (1/1Mhz) * 65536 ==65.536ms)
    TimeBaseInit.PWM_CounterMode = PWM_CounterMode_Up;
	PMW_TimeBaseInit(TIM1, &TimeBaseInit);			//ʼTIM1ʱ
	
	/*벶*/
	PWM_ICStructInit(&CapPutInit);						//ʹĬֵʼCapPutInit
	
	CapPutInit.PWM_Channel = PWM_Channel_1;						//òͨ
	CapPutInit.PWM_ICPolarity =PWM_ICPolarity_BothEdge;	//˫ز
	CapPutInit.PWM_ICRstCount = PWM_ICRstCount_Enable;	//Ƿ񲶻λ
	PWM_ICInit(TIM1,&CapPutInit);						//ʼ벶ͨ
	
	PWM_ITConfig(TIM1,PWM_IE_IC1,ENABLE);				//ʹܲж
	
	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM1_IRQn;	//ж
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;	//Ƿʹж
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;	//жȼ
	NVIC_Init(&NVIC_InitStruct);					//ʼNVIC
	
	PWM_Cmd(TIM1, ENABLE);							//ʹTIM1
}


/**
* @brief ʼTIM2
* @param 
* @retval 
*/
void General_TIMER2_Config(void)
{
	TIM_TimeBaseInitTypeDef TimeBaseInit;
	NVIC_InitTypeDef NVIC_InitStruct;
	
	/*NVIC*/
	NVIC_InitStruct.NVIC_IRQChannel = TIM2_IRQn;		//ж
	NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;		//Ƿʹж
	NVIC_InitStruct.NVIC_IRQChannelPriority = 0x00;		//жȼ
	NVIC_Init(&NVIC_InitStruct);						//ʼNVIC
	
	TIM_TimeBaseStructInit(&TimeBaseInit);				//ʹĬֵʼCapPutInit
	
	TimeBaseInit.Prescaler = 479;						//÷Ƶֵ(24000000/(239-1) = 100000)
	TimeBaseInit.CounterMode = TIM_CounterMode_UP;			//ü
	TimeBaseInit.MatchValue = 2000; 					//װֵ
	TimeBaseInit.OVRSTEN = ENABLE;						//Ƿλ
	
	TIM_TimeBaseInit(TIM2, &TimeBaseInit);				//ʼTIM2
	
	TIM_ITConfig(TIM2, TIMx_IE_UIE, ENABLE);			//ʹܼж
	
	TIM_Cmd(TIM2, ENABLE);								//ʹTIM2
	
}

/**
* @brief TIM1ģ
* @param 
* @retval 
*/
void Tim1_Driver(void)
{
	Advanced_TIMER_GPIO_Config();
	Advanced_TIMER_Mode_Config();
}


int main (void)
{
	u32 capvalue;
	u32 capvalue_2;
	UART_Driver();
	GPIO_PIN_Configure();
	Tim1_Driver();
	General_TIMER2_Config();
	while(1)
	{	
		if(Tim_FLAG==0)
		{
			GPIO_SetBits(GPIOD, GPIO_Pin_4);
		}
		else
		{
			GPIO_ResetBits(GPIOD, GPIO_Pin_4);
		}
		
		if(CapIsr_Flag == 1)
		{
			capvalue = Isr_capture_Value;
			capvalue_2 = Isr_capture_Value_2;
			capvalue = (u16)(capvalue & 0xFFFF);		
			capvalue_2 = (u16)(capvalue_2 & 0xFFFF);
			
			printf("͵ƽʱΪ:%ldus",capvalue);
			printf("ߵƽʱΪ:%ldus\r\n\r\n",capvalue_2);

			CapIsr_Flag = 0;
		}
	}
}
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %lu\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


