/******************************************************************************
  * @Example IIC
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2020/10/14
  * @brief   I2Cο̣ͨI2CAT24C04ʼַ0x00д0x1~0x10ʹôڴӡдͶ
  *          
  ******************************************************************************
  * @attention	Ϊ384001λֹͣλУ
  *				Ϊο̣ʵ֤Ҫ֤弶ӦIC
  *****************************************************************************/
	
#include "PT32X003.h"

#define number_c	1000
u16 IIC_Timeout = 0;
#define BufferSize          16
u8 Tx_Buffer[BufferSize];
u8 Rx_Buffer[BufferSize];

void  Delay_I2C(u32 nCount)
{
	for(; nCount != 0; nCount--);
}

/**
* @brief IICȴӻready
* @param 
* @retval 
*/
void I2C_WaitEEPROMReady(void)
{
	while(1)
	{
		I2C_GenerateSTART(I2C,DISABLE);
		I2C_AcknowledgeConfig(I2C,DISABLE);
		I2C_Cmd(I2C,DISABLE);
		
		I2C_Cmd(I2C,ENABLE);
		I2C_GenerateSTART(I2C,ENABLE);
		
		while(I2C_GetStatus(I2C,I2C_StartOk)!= SET);
		I2C_SendAddr(I2C, 0xA0);
		while(1)
		{
			if(I2C_GetStatus(I2C,I2C_MAS_GetNack_W) == SET)
			{
				break;
			}
			if(I2C_GetStatus(I2C,I2C_MAS_GetAck_W) == SET)
			{
				return;
			}
		}
	}
}

/**
* @brief IICд
* @param pBufferд
* @param WriteAddrӻַ
* @param NumByteToWriteдݳ
* @retval 
*/
void I2C_EE_PageWrite(UINT8* pBuffer, UINT8 WriteAddr, UINT8 NumByteToWrite)
{
	I2C_WaitEEPROMReady();
	I2C_SendData(I2C, WriteAddr);
	while(I2C_GetStatus(I2C,I2C_MDS_GetAck) != SET);
	while (NumByteToWrite--)
	{
		I2C_SendData(I2C, *pBuffer++);
		while(I2C_GetStatus(I2C,I2C_MDS_GetAck) != SET);
	}
	// GenerateSTOP
	I2C_GenerateSTOP(I2C,ENABLE);
	Delay_I2C(50);
}

/**
* @brief IICд
* @param pBufferҪд
* @param WriteAddrӻַ
* @param NumByteToWriteҪдݳ
* @retval 
*/
void I2C_EE_BufferWrite(UINT8* pBuffer, UINT8 WriteAddr, UINT16 NumByteToWrite)
{
	UINT16 Byte2Wr;
	while (NumByteToWrite)
	{
		Byte2Wr = (NumByteToWrite > 16) ? (16 - (WriteAddr & 0x0F)) : (NumByteToWrite);
		I2C_EE_PageWrite(pBuffer, WriteAddr, Byte2Wr);
		pBuffer += Byte2Wr;
		WriteAddr += Byte2Wr;
		NumByteToWrite -= Byte2Wr;
	}
}

/**
* @brief IIC
* @param 
* @retval 
*/
void I2C_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_4, AFIO_AF_0,ENABLE);	//SCLֹܸ
	GPIO_DigRemapConfig(AFIOB, AFIO_Pin_5, AFIO_AF_0,ENABLE);	//SDAֹܸ
}

/**
* @brief IIC
* @param pBuffer
* @param ReadAddrӻַ
* @param NumByteToReadݳ
* @retval 
*/
void I2C_EE_BufferRead(UINT8* pBuffer, UINT8 ReadAddr, UINT16 NumByteToRead)
{
	u16 read_count;
	I2C_WaitEEPROMReady();
	I2C_SendData(I2C, ReadAddr);
	while(I2C_GetStatus(I2C,I2C_MDS_GetAck) != SET);
	
	I2C_GenerateSTART(I2C,DISABLE);
	I2C_AcknowledgeConfig(I2C,DISABLE);
	I2C_Cmd(I2C,DISABLE);
	
	I2C_Cmd(I2C,ENABLE);
	I2C_GenerateSTART(I2C,ENABLE);
	
	while(I2C_GetStatus(I2C,I2C_StartOk) != SET);
	I2C_SendAddr(I2C, 0xA1);
	while(I2C_GetStatus(I2C,I2C_MAS_SendAck_R) != SET);
	if(NumByteToRead == 1)
	{
		I2C_AcknowledgeConfig(I2C,DISABLE);
	}
	else
	{
		I2C_AcknowledgeConfig(I2C,ENABLE);
	}
	while((I2C_GetStatus(I2C,I2C_MDG_SendAck) != SET) && (I2C_GetStatus(I2C,I2C_MDG_SendNack) != SET));
	for(read_count = 0; read_count < NumByteToRead; read_count++)
	{
		*pBuffer++ = I2C_ReceiveData(I2C);
		if(read_count < (NumByteToRead - 1))
		{
			I2C_AcknowledgeConfig(I2C,ENABLE);
			while(I2C_GetStatus(I2C,I2C_MDG_SendAck) != SET);
		}
		else
		{
			I2C_AcknowledgeConfig(I2C,DISABLE);
			while(I2C_GetStatus(I2C,I2C_MDG_SendNack) != SET);
			*pBuffer++ = I2C_ReceiveData(I2C);
			I2C_GenerateSTOP(I2C,ENABLE);
		}
	}
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_5, AFIO_AF_0,ENABLE);	//RXֹܸ
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_6, AFIO_AF_0,ENABLE);	//TXֹܸ
}

/**
* @brief ʼUARTģĹ乤ʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;						//һUART_InitTypeDef͵Ľṹ
	
	UART_StructInit(&UART_InitStruct);						//ʹĬֵʼUART_InitStruct
	
	UART_InitStruct.UART_BaudRate = 38400;					//ò 
	UART_InitStruct.UART_WordLength = UART_WP_8D;			//λ
	UART_InitStruct.UART_StopBits = UART_STOP_1b;			//ֹͣλ
	UART_InitStruct.UART_Parity = UART_PS_EVEN;				//Уλ
	UART_InitStruct.UART_Mode = UART_RE_Enable;				//RXʹ
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;	//عر
	
	UART_Init(UART0, &UART_InitStruct);						//ʼUART

	UART_Cmd(UART0, ENABLE);								//ʹUART
}

/**
* @brief UARTģ
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

int main (void)
{
	u8 i=0;
	UART_Driver();
	I2C_GPIO_Config();
	I2C->CCR = I2C_CCR_BR;
	I2C->CR = 0x00950000;
	for (i = 0; i < BufferSize; i++)
	{
		Tx_Buffer[i] = i + 1;
		printf("I2C wrirte Data = 0x%x\r\n", Tx_Buffer[i]);
	}
	printf("\r\n");
	I2C_EE_BufferWrite(Tx_Buffer, 0x00, BufferSize);
	I2C_EE_BufferRead(Rx_Buffer, 0x00, BufferSize);
	for (i = 0; i < BufferSize; i++)
	{
		printf("I2C Reads Data = 0x%x\r\n", Rx_Buffer[i]);
	}
	while(1)
	{
	}
}



#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


