/******************************************************************************
  * @Example PT32X003_SPI
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2020/1/27
  * @brief  SPIշػԣͨڴӡյ 
  *          
  ******************************************************************************
  * @attention	Ϊ384001λֹͣλУ
  *				ʹø:
  *							ҪJ14RXPD5̽ӣTXPD6̽
  *							SPI_MOSI0SPI_MISO0̽PC6PC7
  *							PA3 --> SPI_CS0
  *							PC5 --> SPI_SCK0
  *							PC6 --> SPI_MOSI0
  *							PC7 --> SPI_MISO0
  *****************************************************************************/
#include "PT32X003.h"



#define		SPI_MASTER_CS_LOW()		SPI_CSInternalSoftwareConfig(SPI, SPI_NSSInternalSoft_Reset)
#define		SPI_MASTER_CS_HIGH()	SPI_CSInternalSoftwareConfig(SPI, SPI_NSSInternalSoft_Set)

/**
* @brief SPI
* @param 
* @retval 
*/
void SPI_GPIO_Config(void)
{
	GPIO_DigRemapConfig(AFIOA, AFIO_Pin_3, AFIO_AF_1,ENABLE);	//SPI_CSֹܸ
	GPIO_DigRemapConfig(AFIOC, AFIO_Pin_5, AFIO_AF_1,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigRemapConfig(AFIOC, AFIO_Pin_6, AFIO_AF_1,ENABLE);	//SPI_MOSIֹܸ
	GPIO_DigRemapConfig(AFIOC, AFIO_Pin_7, AFIO_AF_1,ENABLE);	//SPI_MISOֹܸ
}

/**
* @brief ʼSPIģĹ乤ʽ
* @param SPIxSPI
* @retval 
*/
void SPI_MasterMode_Config(SPI_TypeDef* SPIx)
{
	SPI_InitTypeDef  SPI_InitStructure;						//һSPI_InitTypeDef͵Ľṹ

	SPI_StructInit(&SPI_InitStructure);						//ʹĬֵʼSPI_InitStructure
	
	/* SPI ģʽ */
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//Ϊģʽ
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;		//֡
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;				//ʱӼԣ״̬ʱSCKָߵƽ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;			//ʱλݲӵڶʱӱؿʼ
	SPI_InitStructure.SPI_CSS = SPI_CSS_Soft;				//CSƣĬϳʼֵΪߵƽ
	SPI_InitStructure.SPI_Prescaler = 0;					//SPIʱӷƵϵ
	SPI_InitStructure.SPI_BaudRatePrescaler = 16;			//SPIԤƵ f(sck)=f(pclk)/(SPI_BaudRatePrescaler*(1+SPI_Prescaler))
    
	SPI_Init(SPI, &SPI_InitStructure);						//ʼSPI
	SPI_CSInternalSoftwareConfig(SPI, SPI_CSSInternalSoft_Set);		//ƬѡźſƣCSߵƽ
	
	SPI_Cmd(SPI, ENABLE);									//ʹSPI
}

/**
* @brief SPIģ
* @param 
* @retval 
*/
void SPI_Driver(void)
{
	SPI_GPIO_Config();
	SPI_MasterMode_Config(SPI);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_5, AFIO_AF_0,ENABLE);	//RXֹܸ
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_6, AFIO_AF_0,ENABLE);	//TXֹܸ
}

/**
* @brief ʼUARTģĹ乤ʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;						//һUART_InitTypeDef͵Ľṹ
	
	UART_StructInit(&UART_InitStruct);						//ʹĬֵʼUART_InitStruct
	
	UART_InitStruct.UART_BaudRate = 38400;					//ò 
	UART_InitStruct.UART_WordLength = UART_WP_8D;			//λ
	UART_InitStruct.UART_StopBits = UART_STOP_1b;			//ֹͣλ
	UART_InitStruct.UART_Parity = UART_Parity_Event;				//Уλ
	UART_InitStruct.UART_Mode = UART_Mode_RxEnable;				//RXʹ
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;	//عر
	
	UART_Init(UART0, &UART_InitStruct);						//ʼUART

	UART_Cmd(UART0, ENABLE);								//ʹUART
}

/**
* @brief UARTģ
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void Delay(u32 nCount)
{
	for(; nCount != 0; nCount--);
}

int main (void)
{
	u8 i = 0;
	u8 tx_data[5]={1,2,3,4,5};
	u8 rx_data[5]={0};
	UART_Driver();
	SPI_Driver();	
	while(1)
	{
		i=0;
		while(i<5)
		{
			while(!SPI_GetFlagStatus(SPI,SPI_FLAG_TXE));	//FIFOΪ
			SPI_SendData(SPI,tx_data[i]);
			
			while(!SPI_GetFlagStatus(SPI,SPI_FLAG_RXNE));	//FIFOǿ
			rx_data[i] = SPI_ReceiveData(SPI);			
			i++;
		}	
		i=0;
		while(i<5)
		{
			Delay(1000000);
			printf("rx_data[%d] = %d \r\n",i,rx_data[i]);		
			i++;
		}
	}
	
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %lu\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


