  /******************************************************************************
  * @Example PT32X003_IFMC
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2020/1/27
  * @brief   ͨIFMCƬFLASHַָд5ֵ,ȡ
  *          
  ******************************************************************************
  * @attention	Ϊ384001λֹͣλУ
	*			ʹø̣
	*					ҪJ20RXPD5̽ӣTXPD6̽
  *
  *****************************************************************************/

#include "PT32X003.h"

#define WRITE_START_ADDR  ((u32)0x00002E00)	
#define WRITE_END_ADDR    MAINCODE_END_ADDR

u32 IFMC_Data[5]={0};
u32 Rx_Buffer[5];


void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<20; i++)
		for(j=0; j<20; j++)
			for(x=0; x<20; x++);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_5, AFIO_AF_0,ENABLE);	//TXֹܸ
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_6, AFIO_AF_0,ENABLE);	//RXֹܸ
}

/**
* @brief ʼUARTģĹ乤ʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;						//һUART_InitTypeDef͵Ľṹ
	
	UART_StructInit(&UART_InitStruct);						//ʹĬֵʼUART_InitStruct
	
	UART_InitStruct.UART_BaudRate = 38400;					//ò 
	UART_InitStruct.UART_WordLength = UART_WP_8D;			//λ
	UART_InitStruct.UART_StopBits = UART_STOP_1b;			//ֹͣλ
	UART_InitStruct.UART_Parity = UART_PS_EVEN;				//Уλ
	UART_InitStruct.UART_Mode = UART_RE_Enable;				//RXʹ
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;	//عر
	
	UART_Init(UART0, &UART_InitStruct);						//ʼUART

	UART_Cmd(UART0, ENABLE);								//ʹUART
}

/**
* @brief UARTģ
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief FLASH
* @param 
* @retval 
*/
void Flash_Erase(void)
{
	u32 EraseCounter = 0x00;																				//ҪĿ
	u32 NbrOfPage = 0x00;																					//
	FLASH_Status FLASHStatus = IFMC_Complete; 																//Ľ
	
	NbrOfPage = (WRITE_END_ADDR - WRITE_START_ADDR) / FLASH_PAGE_SIZE;										//Ҫٿ(1=512Byte)
	
	IFMC_ClearFlag(IFMC_SR_WOV | IFMC_SR_POV | IFMC_SR_COV | IFMC_SR_KERR | IFMC_SR_CERR | IFMC_SR_AERR);	//б־λ
	
	for(EraseCounter = 0; (EraseCounter <= NbrOfPage) && (FLASHStatus == IFMC_Complete); EraseCounter++)	//
	{
		FLASHStatus = IFMC_ErasePage(WRITE_START_ADDR + (FLASH_PAGE_SIZE * EraseCounter));
	}
}

/**
* @brief FLASHȷ
* @param 
* @retval Flash_Flag0Ѿдݣ1δд
*/
u8 Flash_Check(void)
{
	u32 Address = 0;														//дַ
	u8 Count_Write=0;														//д
	u8 Flash_Flag=0;
	Address = WRITE_START_ADDR;												//дַ
	while((Count_Write < 5))
	{
		if((*(__IO u32*) Address) != IFMC_Data[Count_Write])				//дַȷ
		{
			Flash_Flag=1;
		}
		Address += 4;
		Count_Write++;
	}
	return Flash_Flag;
}

/**
* @brief FLASHд
* @param 
* @retval 
*/
void Flash_Write_WordCode(void)
{
	FLASH_Status FLASHStatus = IFMC_Complete; 										//Ľ
	u32 Address = 0;																//дַ
	u8 Count_Write=0;																//д
	Flash_Erase();																	//FLASH
	
	Address = WRITE_START_ADDR;
	while((Count_Write < 5) && (FLASHStatus == IFMC_Complete))						//жFLASH״̬
	{
		FLASHStatus = IFMC_ProgramWord(Address, IFMC_Data[Count_Write]);       		//ýӿд
		printf("дΪ:%#lX--ַ:%lX\r\n",IFMC_Data[Count_Write],Address);
		Address = Address + 4;	
		Count_Write++;
	}

	if(FLASHStatus == IFMC_AddrError)
	{
		printf("ַ\r\n");
		while(1);
	}

}

/**
* @brief FLASH
* @param 
* @retval 
*/
void Flash_Read_WordCode()
{
	u32 Address = 0;																//ȡַ	
	u8 Count_Write=0;																//ȡ
	u32 tmpreg = 0;
	Address = WRITE_START_ADDR;
	tmpreg = IFMC->CR;
	tmpreg &= ~ (0x000010F);
	tmpreg |= (IFMC_CR_KEY_MAIN & (~FLASH_OPMOD_WR));
	IFMC->CR = tmpreg;																//IFMC->CR
	while((Count_Write < 5) && !(IFMC->SR&IFMC_SR_BUSY))							//BUSY״̬
	{
		Rx_Buffer[Count_Write] = IFMC_ReadWord(Address);							//ýӿڶ
		printf("Ϊ%#lX--ַ%lX\r\n",Rx_Buffer[Count_Write],Address);
		Address = Address + 4;	
		Count_Write++;		
	}
		printf("ڲFLASH\r\n");
}

int main (void)
{
	u8 Flash_Flag=0;
	Software_Delay();
	
	UART_Driver();
	
	IFMC_Data[0]=0x3210ABCD;														//дֵ
	IFMC_Data[1]=0x4210ABCD;
	IFMC_Data[2]=0x5210ABCD;
	IFMC_Data[3]=0x6210ABCD;
	IFMC_Data[4]=0x7210ABCD;
	Flash_Flag=Flash_Check();
	if(Flash_Flag==0)	
		printf("ѾִйFlash\r\n\r\n");
	else
	{
		printf("ʼдڲFLASH\r\n");
		Flash_Write_WordCode();
		
		printf("ʼڲFLASH\r\n");
		Flash_Read_WordCode();
		printf("*******************************************************************************\r\n");
	}
	while(1)
	{
		
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %lu\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


